import os
from abc import ABC, abstractmethod

from cpl_core.dependency_injection import ServiceProviderABC
from mysql.connector.cursor import MySQLCursorBuffered

from bot_data.db_context import DBContext


class MigrationABC(ABC):
    name = None
    prio = 0

    @abstractmethod
    @ServiceProviderABC.inject
    def __init__(self, db: DBContext):
        self._cursor: MySQLCursorBuffered = db.cursor

    @abstractmethod
    def upgrade(self):
        pass

    @abstractmethod
    def downgrade(self):
        pass

    def _exec(self, self_file: str, file: str):
        path = f"{os.path.dirname(os.path.realpath(self_file))}/db_history_scripts"
        sql = open(f"{path}/{file}").read()

        for statement in sql.split("\n\n"):
            self._cursor.execute(statement + ";")
