ALTER TABLE `UserJoinedServers`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserJoinedServers`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserJoinedServersHistory`
(
    `Id`   BIGINT(20)  NOT NULL,
    `UserId`   BIGINT(20)  NOT NULL,
    `JoinedOn` DATETIME(6) NOT NULL,
    `LeavedOn` DATETIME(6) DEFAULT NULL,
    `Deleted`  BOOL        DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo`   DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserJoinedServersUpdate`;

CREATE TRIGGER `TR_UserJoinedServersUpdate`
    AFTER UPDATE
    ON `UserJoinedServers`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedServersHistory` (
        `Id`, `UserId`, `JoinedOn`, `LeavedOn`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.JoinId, OLD.UserId, OLD.JoinedOn, OLD.LeavedOn, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserJoinedServersDelete`;

CREATE TRIGGER `TR_UserJoinedServersDelete`
    AFTER DELETE
    ON `UserJoinedServers`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedServersHistory` (
        `Id`, `UserId`, `JoinedOn`, `LeavedOn`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.JoinId, OLD.UserId, OLD.JoinedOn, OLD.LeavedOn, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;